diff --git a/storage/innobase/handler/handler0alter.cc b/storage/innobase/handler/handler0alter.cc
index dfb5d0f..7bc1384 100644
--- a/storage/innobase/handler/handler0alter.cc
+++ b/storage/innobase/handler/handler0alter.cc
@@ -1173,7 +1173,11 @@ int ha_innobase::parallel_scan_init(void *&scan_ctx, size_t &num_threads) {
 
   trx_start_if_not_started_xa(trx, false);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->read_view.open(trx);
+#else
   trx_assign_read_view(trx);
+#endif
 
   size_t n_threads = thd_parallel_read_threads(m_prebuilt->trx->mysql_thd);
 
@@ -4778,7 +4782,11 @@ static MY_ATTRIBUTE((warn_unused_result)) bool prepare_inplace_alter_table_dict(
   if (ctx->online) {
     /* Assign a consistent read view for
     row_merge_read_clustered_index(). */
+#ifdef HAVE_LOCK_FREE_READVIEW
+    ctx->prebuilt->trx->read_view.open(ctx->prebuilt->trx);
+#else
     trx_assign_read_view(ctx->prebuilt->trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
   if (fts_index) {
@@ -9750,7 +9758,11 @@ int ha_innopart::parallel_scan_init(void *&scan_ctx, size_t &num_threads) {
 
   trx_start_if_not_started_xa(trx, false);
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx->read_view.open(trx);
+#else
   trx_assign_read_view(trx);
+#endif
 
   const Parallel_reader::Scan_range FULL_SCAN{};
 
diff --git a/storage/innobase/handler/p_s.cc b/storage/innobase/handler/p_s.cc
index 74c9f94..b3fe28e 100644
--- a/storage/innobase/handler/p_s.cc
+++ b/storage/innobase/handler/p_s.cc
@@ -143,6 +143,11 @@ this program; if not, write to the Free Software Foundation, Inc.,
 static const char *g_engine = "INNODB";
 static const size_t g_engine_length = 6;
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+inline trx_t *get_next_trx(const trx_t *trx) {
+  return (UT_LIST_GET_NEXT(trx_list, trx));
+}
+#else
 inline trx_t *get_next_trx(const trx_t *trx, bool read_write) {
   if (read_write) {
     return (UT_LIST_GET_NEXT(trx_list, trx));
@@ -150,10 +155,17 @@ inline trx_t *get_next_trx(const trx_t *trx, bool read_write) {
     return (UT_LIST_GET_NEXT(mysql_trx_list, trx));
   }
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Pass of a given scan. */
 enum scan_pass {
   INIT_SCANNING,
+#ifdef HAVE_LOCK_FREE_READVIEW
+  /** Scan the trx list.
+  @sa trx_sys_t::trx_list
+  */
+  SCANNING_TRX_LIST,
+#else
   /** Scan the RW trx list.
   @sa trx_sys_t::rw_trx_list
   */
@@ -162,6 +174,7 @@ enum scan_pass {
   @sa trx_t::mysql_trx_list
   */
   SCANNING_MYSQL_TRX_LIST,
+#endif /* HAVE_LOCK_FREE_READVIEW */
   DONE_SCANNING
 };
 
@@ -202,6 +215,17 @@ class Innodb_trx_scan_state {
       m_next_trx_id_range = TRX_ID_MAX;
     } else {
       switch (m_scan_pass) {
+#ifdef HAVE_LOCK_FREE_READVIEW
+        case INIT_SCANNING:
+          m_scan_pass = SCANNING_TRX_LIST;
+          m_start_trx_id_range = 0;
+          m_end_trx_id_range = SCAN_RANGE;
+          m_next_trx_id_range = TRX_ID_MAX;
+          break;
+        case SCANNING_TRX_LIST:
+          m_scan_pass = DONE_SCANNING;
+          break;
+#else
         case INIT_SCANNING:
           m_scan_pass = SCANNING_RW_TRX_LIST;
           m_start_trx_id_range = 0;
@@ -217,6 +241,7 @@ class Innodb_trx_scan_state {
         case SCANNING_MYSQL_TRX_LIST:
           m_scan_pass = DONE_SCANNING;
           break;
+#endif /* HAVE_LOCK_FREE_READVIEW */
         case DONE_SCANNING:
         default:
           ut_error;
@@ -350,6 +375,41 @@ class Innodb_data_lock_wait_iterator
   Innodb_trx_scan_state m_scan_state;
 };
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** Check if a transaction should be discarded.
+Transactions present in the trx list that have not started yet
+are discarded, when inspecting data locks.
+@param[in] trx Transaction to evaluate
+@returns True if the trx should be discarded
+*/
+bool discard_trx(const trx_t *trx) { return !trx_is_started(trx); }
+
+/** Find a transaction in a TRX LIST.
+@param[in] trx_id	The transaction id
+@param[in] trx_list	The transaction list
+@returns The transaction when found, or NULL
+*/
+static const trx_t *fetch_trx_in_trx_list(uint64_t filter_trx_immutable_id,
+                                          trx_ut_list_t *trx_list) {
+  const trx_t *trx;
+
+  ut_ad(lock_mutex_own());
+  ut_ad(trx_sys->mutex.is_owned());
+
+  for (trx = UT_LIST_GET_FIRST(*trx_list); trx != NULL;
+       trx = get_next_trx(trx)) {
+    if (discard_trx(trx)) {
+      continue;
+    }
+
+    if (filter_trx_immutable_id == trx_immutable_id(trx)) {
+      return trx;
+    }
+  }
+
+  return nullptr;
+}
+#else
 /** Check if a transaction should be discarded.
 Transactions present in any TRX LIST that have not started yet
 are discarded, when inspecting data locks.
@@ -398,6 +458,7 @@ static const trx_t *fetch_trx_in_trx_list(uint64_t filter_trx_immutable_id,
 
   return NULL;
 }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 Innodb_data_lock_inspector::Innodb_data_lock_inspector() {}
 
@@ -586,6 +647,16 @@ bool Innodb_data_lock_iterator::scan(PSI_server_data_lock_container *container,
   lock_mutex_enter();
 
   trx_sys_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+
+  size_t found = 0;
+
+  while ((m_scan_state.get_pass() == SCANNING_TRX_LIST) && (found == 0)) {
+    found = scan_trx_list(container, with_lock_data, true, &trx_sys->trx_list);
+    m_scan_state.prepare_next_scan();
+  }
+
+#else
 
   size_t found = 0;
 
@@ -601,6 +672,7 @@ bool Innodb_data_lock_iterator::scan(PSI_server_data_lock_container *container,
     m_scan_state.prepare_next_scan();
   }
 
+#endif /* HAVE_LOCK_FREE_READVIEW */
   trx_sys_mutex_exit();
 
   lock_mutex_exit();
@@ -632,6 +704,15 @@ bool Innodb_data_lock_iterator::fetch(PSI_server_data_lock_container *container,
   lock_mutex_enter();
 
   trx_sys_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+
+  trx = fetch_trx_in_trx_list(trx_immutable_id, &trx_sys->trx_list);
+
+  if (trx != nullptr) {
+    scan_trx(container, with_lock_data, trx, true, lock_immutable_id, heap_id);
+  }
+
+#else
 
   trx = fetch_trx_in_trx_list(trx_immutable_id, true, &trx_sys->rw_trx_list);
 
@@ -644,6 +725,7 @@ bool Innodb_data_lock_iterator::fetch(PSI_server_data_lock_container *container,
     scan_trx(container, with_lock_data, trx, true, lock_immutable_id, heap_id);
   }
 
+#endif /* HAVE_LOCK_FREE_READVIEW */
   trx_sys_mutex_exit();
 
   lock_mutex_exit();
@@ -667,6 +749,24 @@ size_t Innodb_data_lock_iterator::scan_trx_list(
   size_t found = 0;
 
   ut_ad(lock_mutex_own());
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx_sys->mutex.is_owned());
+
+  for (trx = UT_LIST_GET_FIRST(*trx_list); trx != nullptr;
+       trx = get_next_trx(trx)) {
+    if (discard_trx(trx)) {
+      continue;
+    }
+
+    trx_id = trx_get_id_for_print(trx);
+
+    if (!m_scan_state.trx_id_in_range(trx_id)) {
+      continue;
+    }
+
+    found += scan_trx(container, with_lock_data, trx, false);
+  }
+#else
   ut_ad(trx_sys_mutex_own());
 
   for (trx = UT_LIST_GET_FIRST(*trx_list); trx != NULL;
@@ -683,6 +783,7 @@ size_t Innodb_data_lock_iterator::scan_trx_list(
 
     found += scan_trx(container, with_lock_data, trx, false);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   return found;
 }
@@ -859,6 +960,16 @@ bool Innodb_data_lock_wait_iterator::scan(
   lock_mutex_enter();
 
   trx_sys_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+
+  size_t found = 0;
+
+  while ((m_scan_state.get_pass() == SCANNING_TRX_LIST) && (found == 0)) {
+    found = scan_trx_list(container, true, &trx_sys->trx_list);
+    m_scan_state.prepare_next_scan();
+  }
+
+#else
 
   size_t found = 0;
 
@@ -872,6 +983,7 @@ bool Innodb_data_lock_wait_iterator::scan(
     m_scan_state.prepare_next_scan();
   }
 
+#endif /* HAVE_LOCK_FREE_READVIEW */
   trx_sys_mutex_exit();
 
   lock_mutex_exit();
@@ -918,6 +1030,16 @@ bool Innodb_data_lock_wait_iterator::fetch(
   lock_mutex_enter();
 
   trx_sys_mutex_enter();
+#ifdef HAVE_LOCK_FREE_READVIEW
+
+  trx = fetch_trx_in_trx_list(requesting_trx_immutable_id, &trx_sys->trx_list);
+
+  if (trx != nullptr) {
+    scan_trx(container, trx, true, requesting_lock_immutable_id,
+             blocking_lock_immutable_id);
+  }
+
+#else
 
   trx = fetch_trx_in_trx_list(requesting_trx_immutable_id, true,
                               &trx_sys->rw_trx_list);
@@ -932,6 +1054,7 @@ bool Innodb_data_lock_wait_iterator::fetch(
              blocking_lock_immutable_id);
   }
 
+#endif /* HAVE_LOCK_FREE_READVIEW */
   trx_sys_mutex_exit();
 
   lock_mutex_exit();
@@ -953,6 +1076,24 @@ size_t Innodb_data_lock_wait_iterator::scan_trx_list(
   size_t found = 0;
 
   ut_ad(lock_mutex_own());
+#ifdef HAVE_LOCK_FREE_READVIEW
+  ut_ad(trx_sys->mutex.is_owned());
+
+  for (trx = UT_LIST_GET_FIRST(*trx_list); trx != nullptr;
+       trx = get_next_trx(trx)) {
+    if (discard_trx(trx)) {
+      continue;
+    }
+
+    trx_id = trx_get_id_for_print(trx);
+
+    if (!m_scan_state.trx_id_in_range(trx_id)) {
+      continue;
+    }
+
+    found += scan_trx(container, trx, false);
+  }
+#else
   ut_ad(trx_sys_mutex_own());
 
   for (trx = UT_LIST_GET_FIRST(*trx_list); trx != NULL;
@@ -969,6 +1110,7 @@ size_t Innodb_data_lock_wait_iterator::scan_trx_list(
 
     found += scan_trx(container, trx, false);
   }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   return found;
 }
diff --git a/storage/innobase/include/clone0repl.h b/storage/innobase/include/clone0repl.h
index 625b6e0..92d0275 100644
--- a/storage/innobase/include/clone0repl.h
+++ b/storage/innobase/include/clone0repl.h
@@ -235,7 +235,9 @@ class Clone_persist_gtid {
 
   /** @return current active GTID list */
   Gitd_info_list &get_active_list() {
+#ifndef HAVE_LOCK_FREE_READVIEW
     ut_ad(trx_sys_mutex_own());
+#endif
     return (get_list(m_active_number));
   }
 
@@ -292,7 +294,9 @@ class Clone_persist_gtid {
   /** Switch active GTID list. */
   uint64_t switch_active_list() {
     /* Switch active list under transaction system mutex. */
+#ifndef HAVE_LOCK_FREE_READVIEW
     ut_ad(trx_sys_mutex_own());
+#endif
     uint64_t flush_number = m_active_number;
     ++m_active_number;
     m_compression_gtid_counter += m_num_gtid_mem;
diff --git a/storage/innobase/include/read0read.h b/storage/innobase/include/read0read.h
index eab38c4..49cdc79 100644
--- a/storage/innobase/include/read0read.h
+++ b/storage/innobase/include/read0read.h
@@ -33,6 +33,8 @@ this program; if not, write to the Free Software Foundation, Inc.,
 #ifndef read0read_h
 #define read0read_h
 
+#ifndef HAVE_LOCK_FREE_READVIEW
+
 #include <stddef.h>
 #include <algorithm>
 
@@ -128,4 +130,5 @@ class MVCC {
   view_list_t m_views;
 };
 
+#endif /* HAVE_LOCK_FREE_READVIEW */
 #endif /* read0read_h */
diff --git a/storage/innobase/include/read0types.h b/storage/innobase/include/read0types.h
index 973f101..331c304 100644
--- a/storage/innobase/include/read0types.h
+++ b/storage/innobase/include/read0types.h
@@ -38,13 +38,25 @@ this program; if not, write to the Free Software Foundation, Inc.,
 
 #include "trx0types.h"
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** View is not visible to purge thread. */
+constexpr int32_t READ_VIEW_STATE_CLOSED = 0;
+
+/** View is being opened, purge thread must wait for state change. */
+constexpr int32_t READ_VIEW_STATE_SNAPSHOT = 1;
+
+/** View is visible to purge thread. */
+constexpr int32_t READ_VIEW_STATE_OPEN = 2;
+#else
 // Friend declaration
 class MVCC;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Read view lists the trx ids of those transactions for which a consistent
 read should not see the modifications to the database. */
 
 class ReadView {
+#ifndef HAVE_LOCK_FREE_READVIEW
   /** This is similar to a std::vector but it is not a drop
   in replacement. It is specific to ReadView. */
   class ids_t {
@@ -148,6 +160,7 @@ class ReadView {
 
     friend class ReadView;
   };
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
  public:
   ReadView();
@@ -178,9 +191,13 @@ class ReadView {
       return (true);
     }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+    return (!std::binary_search(m_ids.begin(), m_ids.end(), id));
+#else
     const ids_t::value_type *p = m_ids.data();
 
     return (!std::binary_search(p, p + m_ids.size(), id));
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
   /**
@@ -188,16 +205,62 @@ class ReadView {
   @return true if view sees transaction id */
   bool sees(trx_id_t id) const { return (id < m_up_limit_id); }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  /** Creates a snapshot where exactly the transaction serialized before this
+  point in time are seen in the view.
+
+  @param[in, out] trx transaction */
+  void snapshot(trx_t *trx);
+
+  /** Open a read view where exactly the transaction serialized before this
+  point in time are seen in the view.
+
+  View become visible to purge thread.
+
+  @param[in,out] trx transaction */
+  void open(trx_t *trx);
+#endif /* HAVE_LOCK_FREE_READVIEW */
   /**
   Mark the view as closed */
   void close() {
+#ifdef HAVE_LOCK_FREE_READVIEW
+    int32_t state = m_state.load(std::memory_order_relaxed);
+    ut_ad(state == READ_VIEW_STATE_CLOSED || state == READ_VIEW_STATE_OPEN);
+    if (state == READ_VIEW_STATE_OPEN) {
+      m_state.store(READ_VIEW_STATE_CLOSED, std::memory_order_relaxed);
+    }
+#else
     ut_ad(m_creator_trx_id != TRX_ID_MAX);
     m_creator_trx_id = TRX_ID_MAX;
+#endif /* HAVE_LOCK_FREE_READVIEW */
   }
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  /** m_state getter fir trx_sys::clone_oldest_view() & trx_sys::size(). */
+  int32_t get_state() const { return m_state.load(std::memory_order_acquire); }
+
+  /** Returns ture if view is open.
+
+  Only used by view owner thread, thus we can omit atomic operations. */
+  bool is_open() const {
+    int32_t state = m_state.load(std::memory_order_relaxed);
+    ut_ad(state == READ_VIEW_STATE_OPEN || state == READ_VIEW_STATE_CLOSED);
+    return (state == READ_VIEW_STATE_OPEN);
+  }
+
+  /** Set the creator transaction id.
+
+  This should be set only for views created by RW transactions. */
+  void set_creator_trx_id(trx_id_t id) {
+    ut_ad(id > 0);
+    ut_ad(m_creator_trx_id == 0);
+    m_creator_trx_id = id;
+  }
+#else
   /**
   @return true if the view is closed */
   bool is_closed() const { return (m_closed); }
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /**
   Write the limits to the file.
@@ -244,7 +307,11 @@ class ReadView {
     return (m_low_limit_no <= rhs->m_low_limit_no);
   }
 #endif /* UNIV_DEBUG */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  void copy(const ReadView &other);
+#endif /* HAVE_LOCK_FREE_READVIEW */
  private:
+#ifndef HAVE_LOCK_FREE_READVIEW
   /**
   Copy the transaction ids from the source vector */
   inline void copy_trx_ids(const trx_ids_t &trx_ids);
@@ -273,6 +340,7 @@ class ReadView {
   }
 
   friend class MVCC;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
  private:
   // Disable copying
@@ -295,7 +363,11 @@ class ReadView {
 
   /** Set of RW transactions that was active when this snapshot
   was taken */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  trx_ids_t m_ids;
+#else
   ids_t m_ids;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
   /** The view does not need to see the undo logs for transactions
   whose transaction number is strictly smaller (<) than this value:
@@ -310,6 +382,25 @@ class ReadView {
   trx_id_t m_view_low_limit_no;
 #endif /* UNIV_DEBUG */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+  /** View state.
+
+  It is not defined as enum as it has to be updated using atomic operations.
+  Possible values are READ_VIEW_STATE_CLOSED, READ_VIEW_STATE_SNAPSHOT and
+  READ_VIEW_STATE_OPEN.
+
+  Possible state transfers...
+
+  Start view open:
+  READ_VIEW_STATE_CLOSED -> READ_VIEW_STATE_SNAPSHOT
+
+  Complete view open:
+  READ_VIEW_STATE_SNAPSHOT -> READ_VIEW_STATE_OPEN
+
+  Close view:
+  READ_VIEW_STATE_OPEN -> READ_VIEW_STATE_CLOSED */
+  std::atomic<int32_t> m_state;
+#else
   /** AC-NL-RO transaction view that has been "closed". */
   bool m_closed;
 
@@ -318,6 +409,7 @@ class ReadView {
   /** List of read views in trx_sys */
   byte pad1[64 - sizeof(node_t)];
   node_t m_view_list;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 };
 
 #endif
diff --git a/storage/innobase/include/row0vers.h b/storage/innobase/include/row0vers.h
index e8bf136..68fde81 100644
--- a/storage/innobase/include/row0vers.h
+++ b/storage/innobase/include/row0vers.h
@@ -53,6 +53,9 @@ class ReadView;
  negatives. The caller must confirm all positive results by calling
  trx_is_active() while holding lock_sys->mutex. */
 trx_t *row_vers_impl_x_locked(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,     /*!< in/out: trx of current thread */
+#endif                     /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *rec,          /*!< in: record in a secondary index */
     const dict_index_t *index, /*!< in: the secondary index */
     const ulint *offsets);     /*!< in: rec_get_offsets(rec, index) */
@@ -116,6 +119,9 @@ dberr_t row_vers_build_for_consistent_read(
 /** Constructs the last committed version of a clustered index record,
  which should be seen by a semi-consistent read. */
 void row_vers_build_for_semi_consistent_read(
+#ifdef HAVE_LOCK_FREE_READVIEW
+    trx_t *caller_trx,        /*!< in/out: trx of current thread */
+#endif                        /* HAVE_LOCK_FREE_READVIEW */
     const rec_t *rec,         /*!< in: record in a clustered index; the
                               caller must have a latch on the page; this
                               latch locks the top of the stack of versions
diff --git a/storage/innobase/include/srv0srv.h b/storage/innobase/include/srv0srv.h
index 738f486..90a34d6 100644
--- a/storage/innobase/include/srv0srv.h
+++ b/storage/innobase/include/srv0srv.h
@@ -1149,6 +1149,9 @@ struct export_var_t {
                                           the dba created explicitly. */
   ulint innodb_undo_tablespaces_active;   /*!< number of active undo
                                           tablespaces */
+#ifdef HAVE_LOCK_FREE_READVIEW
+  bool innodb_have_lock_free_readview;
+#endif
 #ifdef UNIV_DEBUG
   ulint innodb_purge_trx_id_age;      /*!< rw_max_trx_no - purged trx_no */
   ulint innodb_purge_view_trx_id_age; /*!< rw_max_trx_no
diff --git a/storage/innobase/include/sync0sync.h b/storage/innobase/include/sync0sync.h
index ed8449e..85b9fea 100644
--- a/storage/innobase/include/sync0sync.h
+++ b/storage/innobase/include/sync0sync.h
@@ -158,6 +158,9 @@ extern mysql_pfs_key_t trx_pool_manager_mutex_key;
 extern mysql_pfs_key_t temp_pool_manager_mutex_key;
 extern mysql_pfs_key_t lock_mutex_key;
 extern mysql_pfs_key_t lock_wait_mutex_key;
+#ifdef HAVE_LOCK_FREE_READVIEW
+extern mysql_pfs_key_t rw_trx_hash_element_mutex_key;
+#endif /* HAVE_LOCK_FREE_READVIEW */
 extern mysql_pfs_key_t trx_sys_mutex_key;
 extern mysql_pfs_key_t srv_sys_mutex_key;
 extern mysql_pfs_key_t srv_threads_mutex_key;
diff --git a/storage/innobase/include/sync0types.h b/storage/innobase/include/sync0types.h
index 0ee4353..b925b8a 100644
--- a/storage/innobase/include/sync0types.h
+++ b/storage/innobase/include/sync0types.h
@@ -267,6 +267,9 @@ enum latch_level_t {
   SYNC_REC_LOCK,
   SYNC_THREADS,
   SYNC_TRX,
+#ifdef HAVE_LOCK_FREE_READVIEW
+  SYNC_RW_TRX_HASH_ELEMENT,
+#endif /* HAVE_LOCK_FREE_READVIEW */
   SYNC_POOL,
   SYNC_POOL_MANAGER,
   SYNC_TRX_SYS,
@@ -452,6 +455,9 @@ enum latch_id_t {
   LATCH_ID_CLONE_SYS,
   LATCH_ID_CLONE_TASK,
   LATCH_ID_CLONE_SNAPSHOT,
+#ifdef HAVE_LOCK_FREE_READVIEW
+  LATCH_ID_RW_TRX_HASH_ELEMENT,
+#endif /* HAVE_LOCK_FREE_READVIEW */
   LATCH_ID_PARALLEL_READ,
   LATCH_ID_REDO_LOG_ARCHIVE_ADMIN_MUTEX,
   LATCH_ID_REDO_LOG_ARCHIVE_QUEUE_MUTEX,
diff --git a/storage/innobase/include/trx0roll.h b/storage/innobase/include/trx0roll.h
index 83c13a9..b6312ed 100644
--- a/storage/innobase/include/trx0roll.h
+++ b/storage/innobase/include/trx0roll.h
@@ -61,6 +61,15 @@ trx_undo_rec_t *trx_roll_pop_top_rec_of_trx(
     roll_ptr_t *roll_ptr, /*!< out: roll pointer to undo record */
     mem_heap_t *heap);    /*!< in: memory heap where copied */
 
+#ifdef HAVE_LOCK_FREE_READVIEW
+/** Rollback or clean up any incomplete transactions which were
+ encountered in crash recovery.  If the transaction already was
+ committed, then we clean up a possible insert undo log. If the
+ transaction was not yet committed, then we roll it back.
+ @param all true=roll back all recovered active transactions;
+ false=roll back any incomplete dictionary transaction */
+void trx_rollback_recovered(bool all);
+#else
 /** Rollback or clean up any incomplete transactions which were
  encountered in crash recovery.  If the transaction already was
  committed, then we clean up a possible insert undo log. If the
@@ -68,6 +77,7 @@ trx_undo_rec_t *trx_roll_pop_top_rec_of_trx(
 void trx_rollback_or_clean_recovered(
     ibool all); /*!< in: FALSE=roll back dictionary transactions;
                 TRUE=roll back all non-PREPARED transactions */
+#endif /* HAVE_LOCK_FREE_READVIEW */
 
 /** Rollback or clean up any incomplete transactions which were
 encountered in crash recovery.  If the transaction already was
